package org.faktorips.tutorial.model.home;

import org.faktorips.runtime.InMemoryRuntimeRepository;
import org.faktorips.values.Decimal;
import org.faktorips.values.Money;
import org.faktorips.runtime.annotation.IpsGenerated;

/**
 * Implementation of HomeExtraCoverageTypeBuilder. A HomeExtraCoverageTypeBuilder provides all
 * functionalities that is needed to create a HomeExtraCoverageType. Note that this is only for
 * testing purpose. All instances of product have to be created in a new
 * {@link InMemoryRuntimeRepository} as Product Component in the runtime repository can not be
 * edited.
 *
 * @generated
 */
public class HomeExtraCoverageTypeBuilder {
    /**
     * @generated
     */
    private final InMemoryRuntimeRepository runtimeRepository;

    /**
     * @generated
     */
    private final HomeExtraCoverageType homeExtraCoverageType;

    /**
     * Generates a new instance of HomeExtraCoverageTypeBuilder with a given product. The product
     * must exist in the given {@link InMemoryRuntimeRepository} that is not allowed to be null.
     *
     * @generated
     */
    @IpsGenerated
    protected HomeExtraCoverageTypeBuilder(HomeExtraCoverageType product, InMemoryRuntimeRepository runtimeRepository) {
        if (product == null || runtimeRepository == null) {
            throw new RuntimeException("Product and repository can not be null!");
        } else {
            runtimeRepository.getExistingProductComponent(product.getId());

            this.runtimeRepository = runtimeRepository;
            this.homeExtraCoverageType = product;
        }
    }

    /**
     * Sets the value of attribute name.
     *
     * @generated
     */
    @IpsGenerated
    public HomeExtraCoverageTypeBuilder name(String name) {
        homeExtraCoverageType.setName(name);
        return this;
    }

    /**
     * Sets the value of attribute factorSumInsured.
     *
     * @generated
     */
    @IpsGenerated
    public HomeExtraCoverageTypeBuilder factorSumInsured(Decimal factorSumInsured) {
        homeExtraCoverageType.setFactorSumInsured(factorSumInsured);
        return this;
    }

    /**
     * Sets the value of attribute maxSumInsured.
     *
     * @generated
     */
    @IpsGenerated
    public HomeExtraCoverageTypeBuilder maxSumInsured(Money maxSumInsured) {
        homeExtraCoverageType.setMaxSumInsured(maxSumInsured);
        return this;
    }

    /**
     * @return {@link InMemoryRuntimeRepository} that is saved.
     *
     * @generated
     */
    @IpsGenerated
    public InMemoryRuntimeRepository getRepository() {
        return this.runtimeRepository;
    }

    /**
     * @return instance of HomeExtraCoverageType that is built.
     *
     * @generated
     */
    @IpsGenerated
    public HomeExtraCoverageType getResult() {
        return homeExtraCoverageType;
    }

    /**
     * Interne Methode
     *
     * @generated
     */
    @IpsGenerated
    public static Class<?> getProductClass() {
        return HomeExtraCoverageType.class;
    }

    /**
     * Creates a new HomeExtraCoverageTypeBuilder with a given HomeExtraCoverageType and a runtime
     * repository.
     *
     * @generated
     */
    @IpsGenerated
    public static HomeExtraCoverageTypeBuilder from(HomeExtraCoverageType product,
            InMemoryRuntimeRepository runtimeRepository) {
        return new HomeExtraCoverageTypeBuilder(product, runtimeRepository);
    }

}
